<?php
/**
* Save notice accept
* @return int
* @param array  $aForm
*/
function saveNoticeAccept( $aForm ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aNoticesAccepts = $oFFS->getData( DB_NOTICES_ACCEPTS, true );

  $aForm['iRequired'] = ( isset( $aForm['iRequired'] ) ) ? 1 : 0;
  $aForm['iStatus'] = ( isset( $aForm['iStatus'] ) ) ? 1 : 0;

  if( isset( $aForm['iNotice'] ) && is_numeric( $aForm['iNotice'] ) && isset( $aNoticesAccepts[$aForm['iNotice']] ) ){
  }
  else{
    $aForm['iNotice'] = $oFFS->throwLastId( DB_NOTICES_ACCEPTS, 'iNotice' ) + 1;
  }

  if( isset( $aForm['iPosition'] ) && !is_numeric( $aForm['iPosition'] ) )
    $aForm['iPosition'] = 0;
  $aNoticesAccepts[$aForm['iNotice']] = changeMassTxt( $aForm, '' );

  $oFFS->saveData( DB_NOTICES_ACCEPTS, createNoticesAcceptsArray( $aNoticesAccepts ) );
  return $aForm['iNotice'];
} // end function saveNoticeAccept

/**
* Saves notices of acceptance
* @return void
* @param array $aForm
*/
function saveNoticesAccepts( $aForm ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aNoticesAccepts = $oFFS->getData( DB_NOTICES_ACCEPTS, true );
  foreach( $aNoticesAccepts as $iNoticeAccept => $aData ){
    if( isset( $aForm['aPositions'][$iNoticeAccept] ) ){
      $iRequired = isset( $aForm['aRequired'][$iNoticeAccept] ) ? 1 : 0;
      $iStatus = isset( $aForm['aStatus'][$iNoticeAccept] ) ? 1 : 0;
      $aForm['aPositions'][$iNoticeAccept] = trim( $aForm['aPositions'][$iNoticeAccept] );

      if( is_numeric( $aForm['aPositions'][$iNoticeAccept] ) && $aForm['aPositions'][$iNoticeAccept] != $aData['iPosition'] ){
        $aNoticesAccepts[$iNoticeAccept]['iPosition'] = $aForm['aPositions'][$iNoticeAccept];
        $bChanged = true;
      }
      if( $iRequired != $aData['iRequired'] ){
        $aNoticesAccepts[$iNoticeAccept]['iRequired'] = $iRequired;
        $bChanged = true;
      }
      if( $iStatus != $aData['iStatus'] ){
        $aNoticesAccepts[$iNoticeAccept]['iStatus'] = $iStatus;
        $bChanged = true;
      }
    }
  } // end foreach

  $aNoticesAccepts = createNoticesAcceptsArray( $aNoticesAccepts );
  if( isset( $bChanged ) ){
    $oFFS = FlatFilesSerialize::getInstance( );
    $oFFS->saveData( DB_NOTICES_ACCEPTS, $aNoticesAccepts );
  }
} // end function saveNoticesAccepts

/**
* Function creates a features array to be saved to the database
* @return array
*/
function createNoticesAcceptsArray( $aData ){
  if( isset( $aData ) ){
    foreach( $aData as $iKey => $aValue ){
      $aSort[$iKey][0] = (int) $aValue['iPosition'];
      $aSort[$iKey][1] = $aValue['sContent'];
      $aSort[$iKey][2] = $aValue['iNotice'];
    } // end foreach

    if( isset( $aSort ) ){
      sort( $aSort );
      
      foreach( $aSort as $iKey => $aValue ){
        $aSave[$aValue[2]] = compareArrays( $GLOBALS['aNoticesAcceptsFields'], $aData[$aValue[2]] );
      } // end foreach

      return $aSave;
    }
  }
} // end function createNoticesAcceptsArray

/**
* Lists the notices to accept
* @return string
*/
function listNoticesAccepts( ){
  global $lang;
  $oFFS = FlatFilesSerialize::getInstance( );
  $aNoticesAccepts = $oFFS->getData( DB_NOTICES_ACCEPTS, true );
  if( isset( $aNoticesAccepts ) && count( $aNoticesAccepts ) > 0 ){
    $content = null;
    $i = 0;
    foreach( $aNoticesAccepts as $aData ){
      $content .= '<tr class="l'.( ( $i % 2 ) ? 0 : 1 ).'"><td>'.$aData['iNotice'].'</td><td><a href="?p=noticesaccepts-form&amp;iNotice='.$aData['iNotice'].'">'.$aData['sContent'].'</a></td><td class="required"><input type="checkbox" name="aRequired['.$aData['iNotice'].']"'.( ( $aData['iRequired'] == 1 ) ? ' checked="checked"' : null ).' value="1" class="checkbox" /></td><td><input type="text" name="aPositions['.$aData['iNotice'].']" value="'.$aData['iPosition'].'" class="inputr" size="2" maxlength="3" /></td><td class="status"><input type="checkbox" name="aStatus['.$aData['iNotice'].']"'.( ( $aData['iStatus'] == 1 ) ? ' checked="checked"' : null ).'  value="1" class="checkbox" /></td><td class="options"><a href="?p=noticesaccepts-form&amp;iNotice='.$aData['iNotice'].'"><img src="'.DIR_TEMPLATES.'admin/img/ico_edit.gif" alt="'.$lang['edit'].'" title="'.$lang['edit'].'" /></a> <a href="?p=noticesaccepts-delete&amp;iNotice='.$aData['iNotice'].'" onclick="return del( \' ?\n'.$lang['Notice_acceptation_confirm'].'\' );"><img src="'.DIR_TEMPLATES.'admin/img/ico_del.gif" alt="'.$lang['delete'].'" title="'.$lang['delete'].'"/></a></td></tr>';
      $i++;
    } // end of foreach
    return $content;
  }
} // end function listNoticesAccepts

/**
* Returns notice to accept data
* @return array
* @param int $iNoticeAccept
*/
function throwNoticeAccept( $iNoticeAccept ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aNoticesAccepts = $oFFS->getData( DB_NOTICES_ACCEPTS, true );
  if( isset( $aNoticesAccepts[$iNoticeAccept] ) ){
    return $aNoticesAccepts[$iNoticeAccept];
  }  
} // end function throwNoticeAccept

/**
* Deletes an acceptance notice
* @return void
* @param int $iNotice
*/
function deleteNoticeAccept( $iNotice ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aNoticesAccepts = $oFFS->getData( DB_NOTICES_ACCEPTS, true );
  if( isset( $aNoticesAccepts[$iNotice] ) ){
    unset( $aNoticesAccepts[$iNotice] );
    $oFFS->saveData( DB_NOTICES_ACCEPTS, $aNoticesAccepts );
  }
} // end function deleteNoticeAccept

/**
* List all checked notices in order
* @return string
* @param array $aOrder
*/
function listNoticesAcceptsInOrderAdmin( $aOrder ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aNoticesAccepts = $oFFS->getData( ( ( LANGUAGE == $aOrder['sLanguage'] ) ? DB_NOTICES_ACCEPTS : str_replace( '/'.LANGUAGE.'_', '/'.$aOrder['sLanguage'].'_', DB_NOTICES_ACCEPTS ) ), true );

  if( isset( $aOrder['aNoticesAccepts'] ) && is_array( $aOrder['aNoticesAccepts'] ) && count( $aOrder['aNoticesAccepts'] ) > 0 && isset( $aNoticesAccepts ) ){
    $content = null;
    $i = 0;
    foreach( $aNoticesAccepts as $iNotice => $aNotice ){
      if( isset( $aOrder['aNoticesAccepts'][$iNotice] ) ){
        $content .= '<tr class="l'.( ( $i % 2 ) ? 0 : 1 ).'"><td>'.$aNotice['sContent'].'</td><td><span>'.throwYesNoTxt( $aOrder['aNoticesAccepts'][$iNotice] ).'</span></td></tr>';
        $i++;
      }
    } // end foreach
  }
  
  if( isset( $content ) )
    return $content;
} // end function listNoticesAcceptsInOrderAdmin
?>